package jp.eisbahn.facebook.servlets;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.facebook.api.FacebookException;
import com.facebook.api.FacebookRestClient;
import com.facebook.api.schema.FriendsGetResponse;

public class SimpleServlet extends HttpServlet {

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        try {
            HttpSession session = request.getSession();
            FacebookRestClient client = (FacebookRestClient)session.getAttribute("__FACEBOOK_CLIENT__");
            List<Message> messageList = getMessageList(session);
            String message = request.getParameter("message");
            String uid = request.getParameter("uid");
            if (message != null && uid != null) {
            	List<Long> uids = new ArrayList<Long>();
            	uids.add(new Long(uid));
            	client.notifications_send(uids, message);
            	Message msg = new Message(message, uid);
            	messageList.add(msg);
            }
            long loggedInUser = client.users_getLoggedInUser();
            request.setAttribute("uid", loggedInUser);
            client.friends_get();
            FriendsGetResponse friendsGetResponse = (FriendsGetResponse)client.getResponsePOJO();
            List<Long> friendUids = friendsGetResponse.getUid();
            request.setAttribute("friendUids", friendUids);
            RequestDispatcher dispatcher = getServletContext().getRequestDispatcher("/WEB-INF/jsp/index.jsp");
            dispatcher.forward(request, response);
        } catch(FacebookException e) {
            throw new ServletException(e);
        }
    }
    
    private List<Message> getMessageList(HttpSession session) {
    	List<Message> messageList = (List<Message>)session.getAttribute("__MESSAGE_LIST__");
    	if (messageList == null) {
    		messageList = new ArrayList<Message>();
    		session.setAttribute("__MESSAGE_LIST__", messageList);
    	}
    	return messageList;
    }

}
